package com.foxconn.countersign;

import java.util.Map;

import org.jbpm.api.activity.ActivityExecution;
import org.jbpm.api.activity.ExternalActivityBehaviour;
import org.jbpm.pvm.internal.env.EnvironmentImpl;
import org.jbpm.pvm.internal.history.HistoryEvent;
import org.jbpm.pvm.internal.history.events.TaskActivityStart;
import org.jbpm.pvm.internal.model.ExecutionImpl;
import org.jbpm.pvm.internal.session.DbSession;
import org.jbpm.pvm.internal.task.TaskImpl;

public class AssignTask implements ExternalActivityBehaviour {
	@Override
	public void execute(ActivityExecution execution) throws Exception {
		// TODO Auto-generated method stub
		ExecutionImpl executionImpl=(ExecutionImpl) execution;
		DbSession dbSession=EnvironmentImpl.getFromCurrent(DbSession.class);
		
		TaskImpl taskImpl=dbSession.createTask();
		taskImpl.setName("mainTask");
		taskImpl.setExecution(executionImpl);
		taskImpl.setProcessInstance(executionImpl.getProcessInstance());
		taskImpl.setSignalling(false);
		taskImpl.setExecutionDbid(executionImpl.getDbid());
		dbSession.save(taskImpl);
		HistoryEvent.fire(new TaskActivityStart(taskImpl),executionImpl);
		
		TaskImpl subTask1=taskImpl.createSubTask();
		subTask1.setName("subtask1");
		subTask1.setAssignee("lizhi");
		subTask1.setSignalling(false);
		subTask1.setExecutionDbid(executionImpl.getDbid());
		dbSession.save(subTask1);
		HistoryEvent.fire(new TaskActivityStart(subTask1),executionImpl);
		
		TaskImpl subTask2=taskImpl.createSubTask();
		subTask2.setName("subtask2");
		subTask2.setAssignee("zhili");
		subTask2.setSignalling(false);
		subTask2.setExecutionDbid(executionImpl.getDbid());
		dbSession.save(subTask2);
		HistoryEvent.fire(new TaskActivityStart(subTask2),executionImpl);
		
		
		execution.waitForSignal();
	}
	@Override
	public void signal(ActivityExecution execution, String signalName, Map<String, ?> parameters)
			throws Exception {
		// TODO Auto-generated method stub
		execution.take(signalName);
	}
}
